// C Header File
// Created 6/11/01; 10:38:54 AM

#ifndef __RLECOMPRESSIONH__
#define __RLECOMPRESSIONH__

enum rle_file {RLE_ERROR, RLE_ENCODED, RLE_DECODED};

//standard rle encoding: used in alot of programs for ti calcs.
unsigned long rle_encode(register unsigned char *out, register unsigned char *in, register unsigned long len);
unsigned long rle_decode(register unsigned char *out, register unsigned char *in, register unsigned long len);

//non standard rle encoding, searches for the least frequent char.
//In some cases, this will produce a result that is one byte larger than rle_encode
//otherwise the result will be smaller. This is slower than rle_encode/decode
unsigned long rle2_encode(register unsigned char *out, register unsigned char *in, register unsigned long len);
unsigned long rle2_decode(register unsigned char *out, register unsigned char *in, register unsigned long len);

//a specialized rle encoding algorithm for data that primarily consists of byte values below 0x80. Fast.
unsigned long rle3_encode(register unsigned char *out, register unsigned char *in, register unsigned long len);
unsigned long rle3_decode(register unsigned char *out, register unsigned char *in, register unsigned long len);

int rle_file(char *out, char *in);

#endif
