// C Source File
// Created 7/17/01; 4:06:47 PM
/*
WARNING: this routine is subject to change! I have some ideas to make it work
even better...

RLE encoding/decoding by Gregory Dietsche 2001.

	Description:
		Uses yet another form of rle encoding; data encoded using this method should
		normally be smaller than than of rle_encode. In the worst case senario, this
		will output one more byte than rle_encode does.
		
	Input:
		out	pointer to buffer for output
		in	pointer to input stream
		len	number of bytes contained in stream in
		
	Output:
		len	the number of bytes in buffer out. If out was NULL then len will be
		the encoded size of buffer in; no decoding will be peformed.
		
	NOTES:
		Sometimes the encoded size of the data will be larger than then original
		data.
		This routine is not finished yet.
*/
inline unsigned char GetMarker(register unsigned char *in, register unsigned long len);

unsigned long rle2_encode(register unsigned char *out, register unsigned char *in, register unsigned long len)
{
	register unsigned char freq;
	register unsigned char byte;
	register unsigned char i;
	register unsigned long posIn     = 0;
	register unsigned long posOut    = 0;
	register unsigned int  RunMarker = GetMarker(in, len);

	if(out)
		out[posOut++]=RunMarker;
	else
		posOut++;
	
	while(posIn<len)
	{
		byte=in[posIn];
		freq=0;

		while(in[++posIn]==byte && freq!=255 && posIn<len)
			freq++;
		
		if(freq<3 && byte!=RunMarker)
		{
			freq++;
		
			if(out)
				for(i=0;i<freq;i++)
					out[posOut++]=byte;
			else
				posOut+=freq;
		}	
		else
		{
			freq++;
		
			if(out)
			{	
				out[posOut++]=RunMarker;
				out[posOut++]=byte;
				out[posOut++]=freq;
			}
			else
				posOut+=3;
		}
	}
	
	return posOut;
}


//Finds the value that repeats the least amount of times in the given set of data
inline unsigned char GetMarker(register unsigned char *in, register unsigned long len)
{
	register unsigned char Marker;
	register unsigned int  x;
	register unsigned long y;
	register unsigned long freq;
					 unsigned long FreqTable[256];
	
	for(x=0;x<256;x++) FreqTable[x] = 0;
	for(y=0;y<len;y++) FreqTable[in[y]]++;
	
	freq = FreqTable[Marker = 0];
	
	for(x=1;x<256;x++)
		if(freq > FreqTable[x])
			freq = FreqTable[Marker = x];
		
	return Marker;
}
