// C Source File
// Created 6/13/01; 9:35:23 AM
/*
RLE encoding/decoding by Gregory Dietsche 2001.

	Description:
		Decodes the Run Length Encoding system used by rle3_encode.
		
	Input:
		out	pointer to buffer for output
		in	pointer to input stream
		len	number of bytes contained in stream in
		
	Output:
		len	the number of bytes in buffer out. If out was NULL then len will be
		the decoded size of buffer in; no decoding will be peformed.

*/
#define RunMarker 0x80
#define FreqMask 0x7f		//RunMarker - 1

unsigned long rle3_decode(register unsigned char *out, register unsigned char *in, register unsigned long len)
{
	register unsigned long PosIn=0;
	register unsigned long PosOut=0;
	register unsigned char byte;
	register unsigned char freq;
	register unsigned char i;
	
	while(PosIn<len)
	{
		if(in[PosIn] & RunMarker)
		{
			freq=in[PosIn++] & FreqMask;
			byte=in[PosIn++];
			
			if(out)
				for(i=0;i<freq;i++)
					out[PosOut++]=byte;
			else
				for(i=0;i<freq;i++)
					PosOut++;
		}
		else
		{
			if(out)
				out[PosOut++]=in[PosIn++];
			else
				PosOut++;
		}
	}
	
	return PosOut;
}
