// C Source File
// Created 6/12/01; 5:34:49 PM
/*
RLE encoding/decoding by Gregory Dietsche 2001.

	Description:
		Decodes the standard TI rle encoding used by most existing programs for
		TI calculators.
		
	Input:
		out	pointer to buffer for output
		in	pointer to input stream
		len	number of bytes contained in stream in
		
	Output:
		len	the number of bytes in buffer out. If out was NULL then len will be
		the decoded size of buffer in; no decoding will be peformed.

*/

#define RunMarker 0x91
	
unsigned long rle_decode(register unsigned char *out, register unsigned char *in, register unsigned long len)
{
	register unsigned long PosIn=0;
	register unsigned long PosOut=0;
	register unsigned char byte;
	register unsigned char freq;
	register unsigned char i;
	
	while(PosIn<len)
	{
		if(in[PosIn]==RunMarker)
		{
			PosIn++;
			byte=in[PosIn++];
			freq=in[PosIn++]-1;	//make a zero into 255 for the loop
			
			if(out)
			{
				for(i=0;i<freq;i++)
					out[PosOut++]=byte;
					
				out[PosOut++]=byte;	//write the last byte
			}
			else
			{
				PosOut+=freq+1;
			}
		}
		else
		{
			if(out)
				out[PosOut++]=in[PosIn++];
			else
			{
				PosOut++;
				PosIn++;
			}
		}
	}
	
	return PosOut;
}
